<template>
  <div>
    <div class="jeecg-basic-table-form-container" @keyup.enter="searchQuery">
        <a-form :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
          <a-row :gutter="24">
                <a-col :lg="6" >
                    <a-form-item :label="searchFormSchema[0].label">
                        <a-input type="like" placeholder="请输入" v-model:value="queryParam[searchFormSchema[0].field]" />
                    </a-form-item>
                </a-col>
                 <a-col :lg="6">
                     <a-form-item :label="searchFormSchema[1].label">
                        <JInput v-model:value="queryParam[searchFormSchema[1].field]" placeholder="请输入" />
                     </a-form-item>
                 </a-col>
                 <a-col :lg="6">
                     <a-form-item :label="searchFormSchema[2].label">
                        <!-- <JSearchSelect v-model:value="queryParam[searchFormSchema[2].field]" placeholder="全部" dict="applyobj" /> -->
                        <StSelectLable :value="queryParam.lableCodes" :allowClear="true" @change="updateSelectLable" />
                     </a-form-item>
                 </a-col>
                 <a-col :lg="6">
                    <a-form-item>
                    <a-space :size="5">
                        <a-button type="link" style="padding:0px" @click="expand = !expand">
                            <template v-if="expand">
                              收缩<UpOutlined style="margin-left:0px"/>
                            </template>
                            <template v-else>
                              展开<DownOutlined style="margin-left:0px"/>
                            </template>
                        </a-button>
                    <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery">查询</a-button>
                    <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset">重置</a-button>
                    </a-space>  
                  </a-form-item>
                  </a-col>
            </a-row>
            <a-row :gutter="24">
              <a-col :lg="6">
                     <a-form-item :label="searchFormSchema[3].label">
                        <JSearchSelect v-model:value="queryParam[searchFormSchema[3].field]" placeholder="全部" dict="eventclassify" :allowClear="true" />
                     </a-form-item>
                 </a-col>
            </a-row>
            <ClassifyCheckbox ref="checkBoxRef" v-show="expand"/>
        </a-form>
            <!--引用表格-->
          <BasicTable @register="registerTable" :rowSelection="rowSelection">
            <!--插槽:table标题-->
              <template #tableTitle>
                  <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新建</a-button>
                  <a-button v-show="showBtn" type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
                  <j-upload-button v-show="showBtn" type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
                  <a-dropdown v-if="selectedRowKeys.length > 0 && showBtn">
                      <template #overlay>
                        <a-menu>
                          <a-menu-item key="1" @click="batchHandleDelete">
                            <Icon icon="ant-design:delete-outlined"></Icon>
                            删除
                          </a-menu-item>
                        </a-menu>
                      </template>
                      <a-button>批量操作
                        <Icon icon="mdi:chevron-down"></Icon>
                      </a-button>
                </a-dropdown>
                <a-button @click="joinCheckHandler">加入检查</a-button>
              </template>
              <template #bodyCell="{ column, record }">
                  <template v-if="column.key === 'riskEventName'">
                    <JEllipsisFormat :value="record.riskEventName" :length="60"/>
                  </template>
                  <template v-else-if="column.key === 'riskEventDesc'">
                    <a @click="handleDetail2(record)"> {{ record.riskEventDesc }}</a>
                  </template>
                  <template v-else-if="column.key === 'lableNameList'">
                    <JTagsFormat :value="record.lableNameList"  :code="record.lableList.split(',')"  :length="4" :strLen="14"  @searchByLable="searchByLable"/>
                  </template>
              </template>
              <!--操作栏-->
              <template #action="{ record }">
                <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
              </template>

            </BasicTable>
  </div>
    <!-- 表单区域 -->
    <StRiskEventModal @register="registerModal" @success="handleSuccess"></StRiskEventModal>
    <JoinCheckModal @register="registerJCModal" @success="handleSuccess"/>
    <StRiskEventModalDetail @register="registerModalDetail" @success="handleSuccess"></StRiskEventModalDetail>
  </div>
</template>

<script lang="ts" name="standardlib-risk-stRiskEventList" setup>
import { DownOutlined, UpOutlined } from '@ant-design/icons-vue';
import { message } from 'ant-design-vue';
import { onMounted, reactive, ref, toRaw, unref } from 'vue';
import { useRoute } from 'vue-router';
import ClassifyCheckbox from '../components/ClassifyCheckbox.vue';
import JEllipsisFormat from '../components/JEllipsisFormat.vue';
import JTagsFormat from '../components/JTagsFormat.vue';
import { batchDelete, deleteOne, getExportUrl, getImportUrl, list } from './StRiskEvent.api';
import { columns, searchFormSchema } from './StRiskEvent.data';
import StRiskEventModal from './components/StRiskEventModal.vue';
import { JInput, JSearchSelect, StSelectLable } from '/@/components/Form';
import { useModal } from '/@/components/Modal';

import { BasicTable, TableAction } from '/@/components/Table';
import { useListPage } from '/@/hooks/system/useListPage';
import { downloadFile } from '/@/utils/common/renderUtils';
import JoinCheckModal from '/@/views/standardlib/components/JoinCheckModal.vue';
import StRiskEventModalDetail from './components/StRiskEventModalDetail.vue';
   const route = useRoute();
  const showBtn = ref(false)
  const expand = ref(false);
  const checkBoxRef = ref(null)
  const checkedKeys = ref<Array<string | number>>([]);
  //注册model
  const [registerModal, {openModal}] = useModal();
  const [registerJCModal, {openModal:openModalJC}] = useModal();
  const [registerModalDetail, {openModal: openModalDetail}] = useModal();
  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '风险事件',
           api: list,
           columns,
           canResize:false,
           showTableSetting: false,
           useSearchForm: false,
           formConfig: {
              //labelWidth: 120,
              schemas: searchFormSchema,
              autoSubmitOnEnter:true,
              showAdvancedButton:true,
              fieldMapToNumber: [
              ],
              fieldMapToTime: [
              ],
            },
           actionColumn: {
               width: 160,
               fixed:'right'
            },
            beforeFetch(params) {
              params = Object.assign(params,{ column: 'updatedTime', order: 'desc' })
            },
      },
       exportConfig: {
            name:"风险事件",
            url: getExportUrl,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {reload,setProps},{ rowSelection, selectedRowKeys }] = tableContext
//-----自定义查询----begin--------
const labelCol = reactive({
  xs: {span: 24},
  sm: {span: 8},
})
const wrapperCol = reactive({
    xs: {span: 24},
    sm: {span: 16},
})
const queryParam = reactive({
  lableCodes:[]
});

// function openItem(data) {
//     handleItem(data)
// }
// function handleItem(record){
//     switchItems.value = true
//     complianeInfoRecord.value = record
//     citemContentRef.value?.initActiveKey(record.complianeNo,record.complianeClass)
// }

function initParam() {
  const schemas = unref(searchFormSchema);
  schemas.forEach((item) => {
    queryParam[item.field] = ''
  });
  queryParam['checkClassFiy'] = null
  queryParam['lableCodes'] = []
}
initParam()
function searchQuery(){
  if(expand.value){
      let checkData = checkBoxRef.value?.getCheckValue()
      if(checkData){
        queryParam['checkClassFiy'] = checkData
      }
    }
    setProps({searchInfo:toRaw(queryParam)});
    reload()
}
function searchReset(){
    checkBoxRef.value?.initQueryParam()
    //Object.assign(queryParam,{ name: '',age_begin: '',age_end: '',sex: '',id: ''});
    initParam()
    reload();
}
function updateSelectLable(val){
  queryParam.lableCodes = val
}
onMounted(()=>{

  const bizNo = toRaw(route.query).bizNo
  const lableCode = toRaw(route.query).lableCode

  if(!!bizNo){
    setProps({searchInfo:{riskEventNo:bizNo}});
    reload()
  }

  if(!!lableCode){
    queryParam.lableCodes=lableCode
    setProps({searchInfo:{lableCodes:[lableCode]}});
    reload()
  }

})
//自定义查询----end--------- 
function joinCheckHandler(){
      let caNos = selectedRowKeys.value
      console.log(caNos)
      if(!caNos||caNos.length==0){
        message.warning('请选择风险事件！');
        return;
      }
      openModalJC(true, {
          record: {caNos:caNos,type:'riskEvent'},
          isUpdate: false,
          showFooter: true,
        });
    }
   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
     });
  }
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }
   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }

   function handleDetail2(record: Recordable) {
     openModalDetail(true, {
       record,
       isUpdate: false,
       showFooter: false,
     });
   }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
       {
           label: '删除',
           color: 'error',
           popConfirm: {
             title: '你确定要删除选中的风险事件吗？',
             confirm: handleDelete.bind(null, record),
           }
         },
         {
           label: '修改',
           onClick: handleEdit.bind(null, record),
         },
         {
           label: '详情',
           onClick: handleDetail2.bind(null, record),
         }, 
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
       return [
        //  {
        //    label: '详情',
        //    onClick: handleDetail.bind(null, record),
        //  }, 
       ]
   }

  function searchByLable(lableCode) {
    if(!lableCode) {
      return 
    }
    queryParam.lableCodes = [];
    queryParam.lableCodes.push(lableCode);
    setProps({searchInfo:{lableCodes:[lableCode]}});
    reload()
  }


</script>

<style scoped>

</style>